diff --git a/rpc/rpc-transport/socket/src/socket.c b/rpc/rpc-transport/socket/src/socket.c
index ed8b473be23..b04847c2231 100644
--- a/rpc/rpc-transport/socket/src/socket.c
+++ b/rpc/rpc-transport/socket/src/socket.c
@@ -948,6 +948,13 @@ __socket_server_bind(rpc_transport_t *this)
                        this->myinfo.identifier, strerror(errno));
                 if (errno == EADDRINUSE) {
                     gf_log(this->name, GF_LOG_ERROR, "Port is already in use");
+                    ret = -EADDRINUSE;
+
+                    /* TODO: Remove this delay. It was added only to address
+                     * failures in the regression test suite, In a real
+                     * situation, if a port is in use when the process starts,
+                     * it most likely will remain in use during 10 seconds as
+                     * well.*/
                     sleep(1);
                     retries--;
                 } else {
@@ -957,19 +964,9 @@ __socket_server_bind(rpc_transport_t *this)
                 break;
             }
         }
-    } else {
-        ret = bind(priv->sock, (struct sockaddr *)&this->myinfo.sockaddr,
-                   this->myinfo.sockaddr_len);
+        if (ret < 0)
+            goto out;
 
-        if (ret != 0) {
-            gf_log(this->name, GF_LOG_ERROR, "binding to %s failed: %s",
-                   this->myinfo.identifier, strerror(errno));
-            if (errno == EADDRINUSE) {
-                gf_log(this->name, GF_LOG_ERROR, "Port is already in use");
-            }
-        }
-    }
-    if (AF_UNIX != SA(&this->myinfo.sockaddr)->sa_family) {
         if (getsockname(priv->sock, SA(&this->myinfo.sockaddr),
                         &this->myinfo.sockaddr_len) != 0) {
             gf_log(this->name, GF_LOG_WARNING,
@@ -985,6 +982,17 @@ __socket_server_bind(rpc_transport_t *this)
                    "process started listening on port (%d)",
                    cmd_args->brick_port);
         }
+    } else {
+        ret = bind(priv->sock, (struct sockaddr *)&this->myinfo.sockaddr,
+                   this->myinfo.sockaddr_len);
+
+        if (ret != 0) {
+            gf_log(this->name, GF_LOG_ERROR, "binding to %s failed: %s",
+                   this->myinfo.identifier, strerror(errno));
+            if (errno == EADDRINUSE) {
+                gf_log(this->name, GF_LOG_ERROR, "Port is already in use");
+            }
+        }
     }
 
 out:
diff --git a/xlators/mgmt/glusterd/src/glusterd-utils.c b/xlators/mgmt/glusterd/src/glusterd-utils.c
index 962557c04e9..eceb19a632c 100644
--- a/xlators/mgmt/glusterd/src/glusterd-utils.c
+++ b/xlators/mgmt/glusterd/src/glusterd-utils.c
@@ -2112,6 +2112,7 @@ glusterd_volume_start_glusterfs(glusterd_volinfo_t *volinfo,
         ret = -1;
         goto out;
     }
+
     /* Build the exp_path, before starting the glusterfsd even in
        valgrind mode. Otherwise all the glusterfsd processes start
        writing the valgrind log to the same file.
@@ -2268,13 +2269,10 @@ glusterd_volume_start_glusterfs(glusterd_volinfo_t *volinfo,
 
     if (wait) {
         synclock_unlock(&priv->big_lock);
-        errno = 0;
         ret = runner_run(&runner);
-        if (errno != 0)
-            ret = errno;
         synclock_lock(&priv->big_lock);
 
-        if (ret == EADDRINUSE) {
+        if (ret == -EADDRINUSE) {
             /* retry after getting a new port */
             gf_msg(this->name, GF_LOG_WARNING, -ret,
                    GD_MSG_SRC_BRICK_PORT_UNAVAIL,
